module gl.ScintillaWidget;

import gl.gl;

alias char uchar;

// Scintilla source code edit control
/** @file ScintillaWidget.h
 ** Definition of Scintilla widget for GTK+.
 ** Only needed by GTK+ code but is harmless on other platforms.
 **/
// Copyright 1998-2001 by Neil Hodgson <neilh@scintilla.org>
// The License.txt file describes the conditions under which this software may be distributed.

//#ifndef SCINTILLAWIDGET_H
//#define SCINTILLAWIDGET_H

//#if PLAT_GTK

//#ifdef __cplusplus
extern(C)
{
//#endif

const int SCINTILLA(obj) = GTK_CHECK_CAST; (obj, scintilla_get_type (), ScintillaObject)
const int SCINTILLA_CLASS(klass) = GTK_CHECK_CLASS_CAST; (klass, scintilla_get_type (), ScintillaClass)
const int IS_SCINTILLA(obj) = GTK_CHECK_TYPE; (obj, scintilla_get_type ())

alias  struct _ScintillaObject ScintillaObject;
alias  struct _ScintillaClass ScintillaClass;

struct _ScintillaObject {
	GtkContainer cont;
	void *pscin;
};

struct _ScintillaClass {
	GtkContainerClass parent_class;

	void (* command) (ScintillaObject *ttt);
	void (* notify) (ScintillaObject *ttt);
};

guint		scintilla_get_type	();
GtkWidget*	scintilla_new		();
void		scintilla_set_id	(ScintillaObject *sci,int id);
sptr_t		scintilla_send_message	(ScintillaObject *sci,unsigned int iMessage, uptr_t wParam, sptr_t lParam);
void		scintilla_release_resources();

//#if GTK_MAJOR_VERSION < 2
const int SCINTILLA_NOTIFY = "notify";
//#else
const int SCINTILLA_NOTIFY = "sci-notify";
//#endif

//#ifdef __cplusplus
}
//#endif

//#endif

//#endif
